import http.client
import requests
import json
import time

class JsonResponse(object):
	 def __init__(self,j):
			self.__dict__ = json.loads(j)

class Timeline(object):
	 def __init__(self,j):
			self.fragments = json.loads(j)
			
class Series(object):
	 def __init__(self,j):
			self.fragments = json.loads(j)

class UsersList(object):
	 def __init__(self,j):
			self.users = json.loads(j)			

class PythonRESTClient:

	def __init__(self, ipaddress, username, password,port):
		self.username = username
		self.password = password
		self.ipaddress = ipaddress
		self.port = port
		self.token = 0
		self.expiretime = ""



	def make_request(self,uri,method,body,headers):
		conn = http.client.HTTPConnection(self.ipaddress,self.port)
		conn.request(method,uri,body,headers)
		response = conn.getresponse()
		#print(response)
		#print(response.status)
		response_body = response.read().decode('UTF-8')
		#print(response_body)
		response_status = response.status
		return response_status, response_body
		
			
		###SPECIALIZED REQUESTS

	def login(self):
		conn = http.client.HTTPConnection(self.ipaddress,self.port)
		myheaders = { "Accept" : "application/json", "Content-Type":"application/x-www-form-urlencoded" }
		body = 'username=' + self.username +'&password='+ self.password
		conn.request("POST","/aggregator/service/auth/login",body,myheaders)
		response = conn.getresponse()
		print(response.status)
		self.token = response.getheader("Authorized-By")
		data = response.read().decode('UTF-8')
		if response.status == 200:
			self.expiretime = int(time.time()) + 3600
		return data


	def getUsersList(self):
		uri = '/aggregator/service/users/useridsandpds2'
		myheaders = { "Authorized-By" : self.token, "Content-Type":"application/json", "Accept":"application/json" }
		conn = http.client.HTTPConnection(self.ipaddress,self.port)
		conn.request("GET",uri,headers=myheaders)
		response = conn.getresponse()
		print("Status: ", response.status)
		userslist = []
		j = json.loads(response.read().decode("UTF-8"))
		#print(j["users"])
		for element in j["users"]:
			userslist.append([element["id"],element["userName"]])
		print(userslist)
		return userslist

	def getEvents(self,uri,method,body):
		#myheaders = '{ "Authorized-By" :"'+ self.token+ '" }'
		myheaders = { "Authorized-By" : self.token, "Content-Type":"application/json", "Accept":"application/json" }
		conn = http.client.HTTPConnection(self.ipaddress,self.port)
		print("url: ",self.ipaddress + uri)
		print("headers: ",myheaders)
		print("body: ",body)
		conn.request(method,uri,body=body,headers=myheaders)
		#pdb.set_trace()
		response = conn.getresponse()
		print(response.status)
		events = []
		data = response.read().decode("UTF-8")
		json_events = json.loads(data)
		for event in json_events["events"]:
			#print(event,"\n")
			events.append(event)
		#print(data)
		return events

	def getEventsIDs(self,uri,method,body):
		#myheaders = '{ "Authorized-By" :"'+ self.token+ '" }'
		myheaders = { "Authorized-By" : self.token, "Content-Type":"application/json", "Accept":"application/json" }
		conn = http.client.HTTPConnection(self.ipaddress,self.port)
		print("url: ",self.ipaddress + uri)
		print("headers: ",myheaders)
		print("body: ",body)
		conn.request(method,uri,body=body,headers=myheaders)
		#pdb.set_trace()
		response = conn.getresponse()
		print(response.status)
		events = []
		data = response.read().decode("UTF-8")
		json_events = json.loads(data)
		#print(json_events)
		for event in json_events["eventsID"]:
			#print(event,"\n")
			events.append(event["id"])
		#print(data)
		return events

	def new_request(self,uri,method,body):
		myheaders = { "Authorized-By" : str(self.token) }
		url = 'http://'+self.ipaddress+':8080'+uri
		r = requests.post(url,data = body, headers=myheaders)
		print(r.text)


