import PythonRESTClient as RESTClient
import json
from datetime import datetime,timezone, timedelta


entrypoint = input("Server ip address or ENTER for default (default 166.111.83.253): ")
if entrypoint == "":
	entrypoint = "166.111.83.253"
port = input("server port or ENTER for default (default 8080): ")
if port == "":
	port = "8080"
username = input("Username: ")
password = input("Password: ")


myRESTClient = RESTClient.PythonRESTClient(entrypoint,username,password,port)


response = myRESTClient.login()

token = myRESTClient.token
print("Token: ", myRESTClient.token)

#json_response = RESTClient.JsonResponse(str(response))
json_response = json.loads(response)


user_id =  json_response["id"]
print("Current user ID: ",user_id)
print("Current username: ", json_response["personalData"]["userName"])


def getData(user_id):
	reqtype = input("Enter type (e.g. RAW_DATA or LABEL): ")
	reqlabel = input("Enter label (e.g. ACC or GYRO or GPS): ")
	if reqlabel == "" and reqtype == "":
		print("Cannot retrieve events with empty type and label")
		return
	starttime = input("Start Time [YYYY-MM-DD hh:mm:ss.msec+zz] (default Yesterday's date): ")
	if starttime == "":
		starttime = (datetime.now() - timedelta(days=1)).replace(tzinfo=timezone.utc,microsecond=0).isoformat()
		print("Default date: ", starttime )
	endtime = input("End Time [YYYY-MM-DD hh:mm:ss.msec+zz] (default Today's date): ")
	if endtime == "":
		endtime = (datetime.now() + timedelta(days=1)).replace(tzinfo=timezone.utc,microsecond=0).isoformat()
		print("Default end date: ",endtime)
	body = '{"startTime":"'+starttime+'","endTime":"'+endtime+'"'
	if reqtype != "":
		body += ',"type":"'+reqtype+'"'
	if reqlabel != "":
		body += ',"label":"'+reqlabel+'"'
	body += '}'
	uri = '/aggregator/service/users/'+str(user_id)+'/events/idbyexample'
	event_ids = myRESTClient.getEventsIDs(uri,'POST',body)
	#print(response)
	for event_id in event_ids:
		print(event_id)

def getLabels(user_id):
	reqtype="LABEL"
	body = '{"type":"'+reqtype+'"}'
	uri = '/aggregator/service/users/'+str(user_id)+'/events/example'
	labels = myRESTClient.getEvents(uri,'POST',body)
	for event in labels:
		print("Start: ", event["startTime"], " end: ", event["endTime"], " Label: ", event["label"])
	return labels

def getUsersList():
	users = myRESTClient.getUsersList()
	print(users)
	for idx,user in enumerate(users):
		print( "Index: ", idx, " - (ID: ", user[0] , ") - ", user[1] )
	selected = input("Select User (0 -"+ str(len(users)-1)+"): ")
	print("New user Selected: ",users[int(selected)][1])
	return users[int(selected)][0]

def getFactoids():
	print("Retrieving conditions:")
	headers = {"Accept":"application/json","Content-Type":"appllication/json"}
	resp_status,resp_body = myRESTClient.make_request("/aggregator/service/conditions","GET","",headers)
	#print(resp_body)
	json_response = json.loads(resp_body)
	available_conditions = []
	headers = { "Content-Type":"application/json","Accept":"application/json"}
	body=""
	for condition in json_response["conditions"]:
		print(condition["value"]+": ")
		url = "/aggregator/service/conditions/"+str(condition["value"])+"/educationals"
		#print(url)
		resp_status,resp_body = myRESTClient.make_request(url,"GET",body,headers)
		#print(resp_status)
		#print(resp_body)
		educationals_json = json.loads(resp_body)
		#print(educationals_json)
		for educational in educationals_json["educationals"]:
			if educational["type"] != "factoid":
				continue
			print("---------------------")
			print("Name: ", educational["name"])
			print("Fact: ", educational["text"])
			print("Suggestion: ", educational["description"])
			print("---------------------")
		#print("Saving "+ name + " for condition "+ cond + " Status: "+resp_status)
		


def addFactoid():
	print("Retrieving conditions:")
	headers = {"Accept":"application/json","Content-Type":"appllication/json"}
	resp_status,resp_body = myRESTClient.make_request("/aggregator/service/conditions","GET","",headers)
	#print(resp_body)
	json_response = json.loads(resp_body)
	available_conditions = []
	for condition in json_response["conditions"]:
		print(condition["value"])
		available_conditions.append(condition["value"])
	selected = input("Enter one of the above conditions or press ENTER to select ALL conditions: ")
	selected_conditions = []
	if selected == "":
		selected_conditions = available_conditions
	elif selected in available_conditions:
		selected_conditions.append(selected)
	else:
		print("Error you must select one or all available conditions")
		return
	print(selected_conditions)
	global token
	name = input("Factoid's title: ")
	fact = input("Factoid's Fact: ")
	suggestion = input("Factoid's suggestion: ")
	headers = {"Authorized-By": token, "Content-Type":"application/json","Accept":"application/json"}
	for cond in selected_conditions:
		body = '{ '#"conditon":{ "value":"'+ str(cond) + '" }, '
		body += '"name":"'+ name +'",'
		body += '"text":"'+ fact +'",'
		body += '"description":"'+ suggestion + '",'
		body += '"urlOfContent": "NOT DEFINED","type":"factoid"}'
		url = "/aggregator/service/conditions/"+str(cond)+"/educationals/new"
		#print("body: ",body)
		#print("headers: ",headers)
		#print("url: ", url)
		resp_status,resp_body = myRESTClient.make_request(url,"POST",body,headers)
		print("Saving "+ name + " for condition "+ str(cond) + " Status: "+str(resp_status))

'''
{
            "condition": {
                "value": "COPD"
            },
            "name": "Morning exercise",
            "text": "A workout session in the morning is a great way to start your day.",
            "description": "Plan a small exercise session every morning.",
            "urlOfContent": "https://webkeepwell.ddns.net/COPD/factoids/morning-exercise/",
            "type": "factoid"
}
'''





def mainMenu():
	global user_id
	selection = input("1. Select other User\n2. Get Data\n3. Get Labels\n4. Get Factoids\n5. Add Factoid\nOr Press any other key to exit\n  ")
	if selection == "1":
		user_id = getUsersList()
	elif selection == "2":
		getData(user_id)
	elif selection == "3":
		getLabels(user_id)
	elif selection == "4":
		getFactoids()
	elif selection == "5":
		addFactoid()
	else:
		return True
	return False


while True:
	if mainMenu():
		break


#reqtype = input("Type: ")
#reqlabel = input("Label: ")





#body = '{"type":"'+reqtype+'","label":"'+reqlabel+'"}'
#uri = '/aggregator/service/users/'+str(user_id)+'/events/idbyexample'
#response = myRESTClient.makerequest(uri,'POST',body)

#print(response)





